# WiFiThermostat - Changelog
## 0.3.3
* DHT sensor reading - retry if failed (does not fix issue)
* improved temperature sensor timeout handling
* updated Adafruit DHT22 sensor lib to 1.3.7 - that seems to have finally fixed the sensor reading issue
* renamed "misc" to "scheduler" as it contains only timing/scheduling functions

## 0.3.2
* fixed/improved: HTTP authentication handling
* added: device hostname (announced via DHCP) can now be configured
* fixed: restart function on web interface
* added: show AP SSID + password on display for some seconds when AP mode is entered

## 0.3.1
* fixed (issue #1): LCD - outside temp - wrong alignment on 1.1 digit values
* added: configurable labels for inside and outside temperature ("I" and "O" in EN or "A" in DE)
* fixed (issue #2): when (new) configuration values are not yet saved, initial values from source code are overwritten with blanks (only for most important values, not for MQTT topics, servers, users etc)

## 0.3.0
* split "mode" to "mode" and "preset", changes in nearly all source files
* add In+Out Temperature display (without humidity) without toggling on LCD line 1
* add publish topic "presetName" and "presetHA", where presetHA returns "none" for default preset and the name for the rest
* add configuration for preset names, off-message, option for non toggling temp display (conf2 page)
* minor fixed in http api and Web-IF
* fixes/improvements in MQTT handling (subscribe to less topics than before using wildcard)
* restart function: when holding down MODE button for >4s, display shows "Restart?". Restart is executed when:
    * MODE button is keeped holding
    * MODE button is pressed/held again as long as the "Restarting?" message is displayed
* return to default operation mode when + or - button is pressed
* changed position of preset mode indicator - now in LCD line 2 after the set temp
* added "flame" symbol in LCD line 2, shown when the heating is active
* added connection symbol (also LCD line 2), depending on received MQTT HEARTBEAT messages
* added fullscreen messages for WiFi connect and MQTT connect
    * shows IP on startup and successful WiFi connection
	* shows AP mode notification and SSID on unsuccessful WiFi connection
	* shows to which MQTT broker we are connected if connecting was successful
* added halfscreen (line 2) notifications - used for displaying the full name of the preset when using the MODE button
* fixed http authentication

## 0.2.2
* Home Assistant direct support (setTemp and setMode topics, real name used in setMode, mode names are configurable)
* added MQTT connection message on LWT topic
* default MQTT_HEARTBEAT_MAXAGE 180000 (former 12000)
* updated PubSubClient to 2.7 (now included in src due to changed parameters)
* minor improvements at MQTT connecting
* added additional publish topic for PIR sensor (configurable)
* bugfixes

## 0.2.1
* added second reduction mode with different set temperature
* MQTT reconnect now tries again every 5 min after 10 fails, finally restarts MCU on 20 unsuccessful retries

## 0.2.0
* improved MQTT reconnection management with heartbeat and force-reconnect
* improved MQTT callback function
* improved overall stability
* added correction value for set point temperature
* added some defines for default values
* added http control api with token
* added mqttReconnect http call
* bugfixes
* some documentation

Important: for now compiled using Arduino 1.8.5 with ESP8266-Arduino core 2.4.0-rc2, as WiFi (re)connection does not work properly in release 2.4.0 (spent many hours on that)!!

## 0.1.3
* button handling now uses library r89m/PushButton.h
* added support for external PIR motion sensor, can be configured to enable display backlight on movement, pushes status to Domoticz and MQTT
* lots of code improvements
* removed unused libraries, added library overview in README.md, included only used libraries
* added some initial description text in README.md
* added heating switch device - send to domoticz/in
* improved MQTT reconnect behavior. Retry every 15s if 1-3 connnects failed and just every 5 min if more to avoid blocking.

## 0.1.2
bugfixes

## 0.1.1
feature complete for now, first alpha

## 0.1.0
initial version, not yet feature complete
